"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var LoggerModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggerModule = void 0;
const common_1 = require("@nestjs/common");
const dotenv_1 = require("dotenv");
const morgan_1 = __importDefault(require("morgan"));
const logger_nest_adapter_1 = require("./logger.nest.adapter");
const logger_service_1 = require("./logger.service");
const logger_types_1 = require("./logger.types");
const console_transport_1 = __importDefault(require("./winston/transports/console.transport"));
const file_transport_1 = __importDefault(require("./winston/transports/file.transport"));
const slack_transport_1 = __importDefault(require("./winston/transports/slack.transport"));
const winston_logger_1 = __importStar(require("./winston/winston.logger"));
const defaultLevels = {
    debug: {
        send: false,
    },
    info: {
        send: false,
    },
    warn: {
        send: false,
    },
    error: {
        send: true,
    },
    emergency: {
        send: true,
    },
    fatal: {
        send: true,
    },
};
(0, dotenv_1.config)();
let LoggerModule = LoggerModule_1 = class LoggerModule {
    constructor(logger) {
        this.logger = logger;
    }
    configure(consumer) {
        consumer
            .apply((0, morgan_1.default)('combined', {
            stream: {
                write: (message) => {
                    const env = process.env.NODE_ENV ?? 'production';
                    if (env.toLowerCase() === 'local') {
                        this.logger.debug(message, 'RequestLogger');
                    }
                },
            },
        }))
            .forRoutes('*');
    }
    static forRoot(options) {
        const levels = { ...defaultLevels, ...options.slack.levels };
        return {
            module: LoggerModule_1,
            imports: [],
            controllers: [],
            providers: [
                {
                    provide: logger_types_1.LoggerBaseKey,
                    useClass: winston_logger_1.default,
                },
                {
                    provide: logger_types_1.LoggerKey,
                    useClass: logger_service_1.LoggerService,
                },
                {
                    provide: logger_nest_adapter_1.LoggerNestAdapter,
                    useFactory: (logger) => new logger_nest_adapter_1.LoggerNestAdapter(logger),
                    inject: [logger_types_1.LoggerKey],
                },
                {
                    provide: winston_logger_1.WinstonLoggerTransportsKey,
                    useFactory: () => {
                        const transports = [];
                        transports.push(console_transport_1.default.create(options.appName));
                        transports.push(file_transport_1.default.create());
                        if (options.slack.enabled) {
                            transports.push(slack_transport_1.default.create({
                                nodeEnv: options.nodeEnv,
                                webhookUrl: options.slack.webhook?.url ?? '',
                                appName: options.appName,
                                levels,
                            }));
                        }
                        return transports;
                    },
                },
            ],
            exports: [logger_types_1.LoggerKey, logger_nest_adapter_1.LoggerNestAdapter],
        };
    }
};
exports.LoggerModule = LoggerModule;
exports.LoggerModule = LoggerModule = LoggerModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({}),
    __param(0, (0, common_1.Inject)(logger_types_1.LoggerKey)),
    __metadata("design:paramtypes", [Object])
], LoggerModule);
